with text_io;use text_io;
with pimage; 
with tree_quater;
with io_exceptions;

procedure main_pimage is

package p_integer is new integer_io(integer);
use p_integer;

procedure write_i ( a: in integer);
function function_gen( a: in integer ) return integer;
-- instanciation of pimage package
package p_image is new pimage(write_i,function_gen);
use p_image;

exit_menu: boolean;
-- test image
im1: image(1..256,1..256);
-- n: dimension of image
n,n_save: integer;
choice: integer;
-- tree to build
tree: tree_im;
-- tolerance
tol: intensity; 
-- threshold
threshold: integer;

-------------------------------------------
---- procedure write_i: procedure passed as
----                   generic parameter;
----                   display element of 
----                   integer type
-------------------------------------------

procedure write_i( a: in integer) is

begin

put(a,0);

end write_i;

-------------------------------------------------
---- function func_gen: function applied to each
----                    element of tree
---- return an integer
------------------------------------------------

function function_gen ( a: integer) return integer is

begin

return (2*a);

end function_gen;

begin

exit_menu:=false;

loop
begin    

    new_line;
    put_line("Make a choice between 1 and 8");
    put_line("1 - Create test image");        
    put_line("2 - Load image from file");    
    put_line("3 - Save current image into file");
    put_line("4 - Display current image");        
    put_line("5 - Load encoded image from file and decompress it into current image");
    put_line("6 - Encode current image and save it into file (compression)");
    put_line("7 - Transform current image into binary image with thresholding");    
    put_line("8 - Exit");

get(choice);

case choice is
                            -- creation of image
                  when 1 => put("Enter the dimension of image to create: "); 
		            get(n);
			    create_im_test(im1,n);
			    -- loading
		  when 2 => load_image(im1,pixel(n));
		            new_line;
		            put("Dimension of image is: ");
			    put(n);
			    new_line;
			    -- saving
		  when 3 => save_image(im1,pixel(n)); 
		            -- display
		  when 4 => display_image(im1,n);
		            -- decompression
		  when 5 => load_im_encod(tree,pixel(n));
		            new_line;
		            put("Dimension of original image is: ");
			    put(n);
			    new_line;
			    put_line("The rebuilt tree is: ");        
					new_line;
			    display_tree(tree);
					new_line;
			    tree_to_im(tree,im1,1,n,1,n);
			    -- compression
		  when 6 => n_save:=n;
		      put("Enter tolerance (between 0 and 100): ");
			    get(tol);
			    im_to_tree(im1,n,tree,tol);
			    n:=n_save;
			    put_line("Built tree is: ");        
					new_line;
			    display_tree(tree);
					new_line;
			    save_imagec(tree,pixel(n));
		            -- thresholding
		  when 7 => new_line;
		            put("Enter threshold value:");
                            get(threshold);
		            thresh_im(im1,n,threshold);	    
                  
		  when 8 => exit_menu:=true;		
		    
		  when others => put("Error, press a key between 1 and 8");

    end case;         

                  exit when exit_menu=true;
		  
exception

  when constraint_error => put_line("Error, access to an unallocated area");
  when io_exceptions.data_error => put_line("Input Error");skip_line;
  
end;
		  
end loop;

end main_pimage;
