with text_io;use text_io;
with tree_nary;

procedure main_tree_nary is


procedure write_int ( a: in integer);
function func_tree ( e: in integer) return integer;
-- instanciation of tree_nary package
package tree_nary_int is new tree_nary(integer,write_int,func_tree);
use tree_nary_int;

package p_integer is new integer_io(integer);
use p_integer;

a,a_r,a_t,tree,tree_ins: tree_nr; -- trees used in main program

e,n: integer; -- values used for input/output
bool: boolean; -- result of Nt_Empty

choice_menu: integer;
exit_menu: boolean;

----------------------------------------------
---- procedure write_int: procedure passed as
----                      generic parameter; 
----                      display each element
----                      of integer type               
----------------------------------------------

procedure write_int( a: in integer) is

begin

put(a,0);

end write_int;

-------------------------------------------------
---- function func_tree: function applied to each
----                     element of tree
---- return an integer
-------------------------------------------------

function func_tree ( e: integer) return integer is

begin

return (2*e);

end func_tree;

-- Begin of main program

begin 

exit_menu:=false;

loop
begin
new_line;
put_line("****************** Test program of package N-Ary Tree ***************");        
put_line("Make a choice between 1 and 20");
put_line("1 - create an empty n-ary tree");
put_line("2 - create a n-ary tree with a value, without child, brother and father");    
put_line("3 - check if a tree is empty or not");    
put_line("4 - return the value of tree root");    
put_line("5 - return the father tree of a tree");
put_line("6 - return the n-th child tree of a tree"); 
put_line("7 - return the n-th brother tree of a tree");
put_line("8 - display all content of a tree");           
put_line("9 - search for a value into a tree and return the tree whose root value is found, otherwise return an empty tree");    
put_line("10 - return the number of children at first level of a tree");
put_line("11 - check if a tree is a leaf (no children)");    
put_line("12 - check if a tree has no father");    
put_line("13 - change the root value of a tree");    
put_line("14 - insert a tree without brother at first child position");    
put_line("15 - insert a tree without brother at first brother position");
put_line("16 - delete the n-th child of tree");
put_line("17 - delete the n-th brother of tree");
put_line("18 - apply a function to each element of tree");                
put_line("19 - initialize a tree");
put_line("20 - exit");
get(choice_menu);

case choice_menu is
-- create an empty tree
when 1 => a:=Nt_Create_Empty; 			       		  
-- create a leaf
when 2 => put_line("Enter a value :");
get(e);
a:=Nt_Create_Leaf(e);
-- check if a tree is empty or not
when 3 => bool:=Nt_Empty(a);
if bool then
put_line("Tree empty");
else
put_line("Tree not empty");
end if;
-- return the value of tree root
when 4 => e:=Nt_Value(a);
write_int(e);
-- return the father tree of a tree
when 5 => a_r:=Nt_Father(a);
-- return the n-th chil tree of a tree
when 6 => put("Enter a number :");
get(n);
a_r:=Nt_Child(a,n);
write_int(Nt_Value(a_r));  			      
-- return the n-th brother tree of a tree
when 7 => put("Enter a number :");
get(n);
a_r:=Nt_Brother(a,n);
write_int(Nt_Value(a_r));  
-- display all content of a tree
when 8 => new_line;
Nt_Display(a);
-- search for a value into a tree
when 9 => put("Enter a number :");
get(e);
a_r:=Nt_Search(a,e);
put("Searched value is : "); 
write_int(Nt_Value(a_r));  
-- return the number of children at first level of a tree   
when 10 => n:=Nt_Number_Children(a);
put("Number of children");
put(n);
new_line;
-- check if a tree is a leaf
when 11 => bool:=Nt_Is_Leaf(a);
if bool then
put_line("This tree is a leaf");
else
put_line("This tree is not a leaf");
end if;           
-- check if a tree has no father
when 12 => bool:=Nt_Is_Root(a);
if bool then
put_line("Tree has no father");
else
put_line("Tree has a father");
end if;       
-- change the root value of a tree
when 13 => put("Enter a new value for root tree :");
get(e);
Nt_Change_Value(a,e);
put_line("New value is ");
write_int(Nt_Value(a));  
-- insert a tree without brother at first child position 
when 14 => put("Enter a value :");
get(e);
tree:=Nt_Create_Leaf(e);
for i in 1..4 loop
put("Enter a value for first child and brothers :");
get(e);
tree_ins:=Nt_Create_leaf(e);
Nt_Insert_Child(tree,tree_ins);
end loop;
a:=tree;
-- insert a tree without brother at first brother position     
when 15 => for i in 1..4 loop
put("Enter a value for first child and brothers :");
get(e);
tree_ins:=Nt_Create_Leaf(e);
Nt_Insert_Brother(a,tree_ins);
end loop;
-- delete the n-th child of a tree
when 16 => put("Enter the number of child to delete :");
get(n); 
Nt_Delete_Child(a,n);
-- delete the n-th brother of a tree
when 17 => put("Enter the number of brother to delete :");
get(n); 
Nt_Delete_Brother(a,n);
-- apply the function passed as generic parameter
when 18 => Nt_Change(a);	       
-- initialization procedure
when 19 => put("Enter a value :");
get(e);
tree:=Nt_Create_Leaf(e);
for i in 1..4 loop
put("Enter a value for first child and brothers :");
get(e);
tree_ins:=Nt_Create_Leaf(e);
Nt_Insert_Child(tree,tree_ins);
end loop;			     			     

for i in 1..2 loop
put("Enter a value for 2th and 3th child :");
get(e);
tree_ins:=Nt_Create_Leaf(e);
Insert_First_Child(tree,tree_ins);    
end loop;

for i in 1..4 loop
put("Enter a value for first child and brothers :");
get(e);
tree_ins:=Nt_Create_Leaf(e);
Nt_Insert_Child(tree,tree_ins);
end loop;

for i in 1..2 loop
put("Enter a value for brothers :");
get(e);
tree_ins:=Nt_Create_Leaf(e);
Nt_Insert_Brother(tree,tree_ins);
end loop;
a:=tree;

when 20 => exit_menu:=true;

when others => put("Error, enter a number between 1 and 20");

end case;         

exit when exit_menu=true;

exception

when constraint_error => put_line("Error, access to an unallocated area");
when tree_empty => put_line("Error, empty tree");
when relation_empty => put_line("Error, relation does not exist");		  
end;
end loop;

end main_tree_nary;

