with text_io;use text_io;
with tree_quater;
with tree_nary;

procedure main_tree_quater is

	procedure write_int ( a: in integer);
	function func_tree ( e: in integer) return integer;

	-- instanciation of tree_quater package
	package tree_quater_int is new tree_quater(integer,write_int,func_tree);
	use tree_quater_int;

	-- instanciation of tree_nary package
	package tree_nary_int is new tree_nary(integer,write_int,func_tree);
	use tree_nary_int;

	package p_integer is new integer_io(integer);
	use p_integer;

	-- trees used in main program
	a,a_r,a_t,tree,tree_ins,a1,a2,a3,a4: tree_quat; 

	e,e1: integer; -- values used in input/output
	bool: boolean; -- result of Qt_Empty

	choice_menu: integer;
	exit_menu: boolean;

	----------------------------------------------
	---- procedure write_int: procedure passed as
	----                       generic parameter;
	----                       display element of
	----                       integer type
	----------------------------------------------

	procedure write_int( a: in integer) is

	begin

		put(a,0);
		new_line;

	end write_int;

	------------------------------------------------
	---- function func_tree: function that we apply
	----                     to each element of tree
	---- return an integer
	------------------------------------------------

	function func_tree ( e: integer) return integer is

	begin

		return (2*e);

	end func_tree;

	-- begin of main program

        begin 

	exit_menu:=false;

	loop
		begin
			new_line;
			put_line("****************** Test program of package Quaternary Tree ***************");    
			put_line("Make a choice between 1 and 18");
			put_line("1 - create an empty quaternary tree");    
			put_line("2 - create a quaternary tree with a value, without child, brother and father");    
			put_line("3 - build a quaternary tree with a value and 4 child trees");        
			put_line("4 - check if a quaternary tree is empty or not");    
			put_line("5 - return the value of root tree");    
			put_line("6 - return the father tree of a tree");
			put_line("7 - return the north-west child of a quaternary tree");               
			put_line("8 - return the north-east child of a quaternary tree");                   
			put_line("9 - return the south-west child of a quaternary tree");                       
			put_line("10 - return the south-east child of a quaternary tree");                           
			put_line("11 - display all content of a quaternary tree");
			put_line("12 - search for a value into a tree and return the tree whose root value is found, otherwise return an empty tree");
			put_line("13 - check if a quaternary tree is a leaf (no children)");
			put_line("14 - check if a quaternary tree has no father");    
			put_line("15 - change the root value of a quaternary tree");
			put_line("16 - apply a function to each element of a quaternary tree");
			put_line("17 - initialize a quaternary tree");
			put_line("18 - exit");
			get(choice_menu);

			case choice_menu is
					-- create an empty tree
				when 1 => a:=Qt_Create_Empty; 			       		  
				-- create a leaf
				when 2 => put_line("Enter a value :");
				get(e);
				a:=Qt_Create_Leaf(e);
				-- building a tree with a value and 4 children
				when 3 => put_line("Enter a value for the father :");
				get(e1);
				put_line("Enter a value for the south-east child :");
				get(e);
				a1:=Qt_Create_Leaf(e);
				put_line("Enter a value for the south-west child :");
				get(e);
				a2:=Qt_Create_Leaf(e);
				put_line("Enter a value for the north-east child :");
				get(e);
				a3:=Qt_Create_Leaf(e);
				put_line("Enter a value for the north-west child :");			    			    
				get(e);
				a4:=Qt_Create_Leaf(e);
				Qt_Build(e1,a4,a3,a2,a1,a);
				-- check if quaternary tree is empty    
				when 4 => bool:=Qt_Empty(a);
				if bool then
					put_line("This tree is empty");
				else
					put_line("This tree is not empty");
				end if;           
				-- return the value of quaternary tree root
				when 5 => e:=Qt_Value(a);
				write_int(e);
				-- return the father tree of a tree       
				when 6 => a_r:=Qt_Father(a);
				-- return the north-west child
				when 7 => a_r:=Qt_North_West(a);
				e:=Qt_Value(a_r);
				put("The value of north-west child is: ");
				write_int(e);      
				-- return the north-east child			    
				when 8 => a_r:=Qt_North_East(a);
				e:=Qt_Value(a_r);
				put("The value of north-east child is: ");
				write_int(e);      			    
				-- return the south-west child			    			    
				when 9 => a_r:=Qt_South_West(a);
				e:=Qt_Value(a_r);
				put("The value of south-west is: ");
				write_int(e);      		
				-- retourne le fils sud est
				when 10 => a_r:=Qt_South_East(a);
				e:=Qt_Value(a_r);
				put("The value of south-east child is: ");
				write_int(e);      			    	        
				-- display all content of tree
				when 11 => Qt_Display(a);
				-- search for a value into a tree
				when 12 => put("Enter a number: ");
				get(e);
				a_r:=Qt_Search(a,e);
				put("Value found is: "); 
				write_int(Qt_Value(a_r));  
				-- check if a quaternary tree is a leaf
				when 13 => bool:=Qt_Is_Leaf(a);
				if bool then
					put_line("This quaternary tree is a leaf");
				else
					put_line("This quaternary tree is not a leaf");			       
				end if;           
				-- check if a tree has no father
				when 14 => bool:=Qt_Is_Root(a);
				if bool then
					put_line("This queternary tree has no father");
				else
					put_line("This queternary tree has a father");
				end if;       
				-- change the value of a tree root
				when 15 => put("Enter the new value for tree root: ");
				get(e);
				Qt_Change_Value(a,e);
				put_line("The new value is: ");
				write_int(Qt_Value(a));
				-- apply the function passed as generic parameter
				when 16 => Qt_Change(a);	
				-- initialization procedure		          
				when 17 => -- first queternary tree
					put_line("Enter a value for father: ");
					get(e1);
					put_line("Enter a value for south-east child: ");			      
					get(e);
					a1:=Qt_Create_Leaf(e);
					put_line("Enter a value for south-west child: ");
					get(e);
					a2:=Qt_Create_Leaf(e);
					put_line("Enter a value for north-east child: ");
					get(e);
					a3:=Qt_Create_Leaf(e);
					put_line("Enter a value for north-west child: ");
					get(e);
					a4:=Qt_Create_Leaf(e);
					Qt_Build(e1,a4,a3,a2,a1,a);
				when 18 => exit_menu:=true;

				when others => put("Error, enter a number between 1 and 18");

			end case;         

			exit when exit_menu=true;

		exception

			when constraint_error => put_line("Error, access to an unallocated area");
			when treeq_empty => put_line("Error, empty tree");
			when relationq_empty => put_line("Error, relation does not exist");		  
			when childq_empty=> put_line("Error, one of the children is empty, cannot build quaternary tree");
		end;
	end loop;

end main_tree_quater;

