-- generic parameters: 
-- values T type of n-ary tree
-- write routine
-- function which acts on all the elements of n-ary tree
  
generic

type T is private;
with procedure write ( a: in T );
with function main_function ( a: in T) return T;

-- specifications part of package

package tree_nary is

type tree_nr is private;

-- exception

-- empty tree
tree_empty: exception;
-- no relation
relation_empty: exception;

-- creation

function Nt_Create_Empty return tree_nr;
function Nt_Create_Leaf(value: in T) return tree_nr;

-- consultation 

function Nt_Empty ( a: in tree_nr ) return boolean;
function Nt_Value ( a: in tree_nr ) return T;
function Nt_Father ( a: in tree_nr ) return tree_nr;
function Nt_Child ( a: in tree_nr; n: in integer ) return tree_nr;
function Nt_Brother ( a: in tree_nr; n: in integer ) return tree_nr;
procedure Nt_Display ( a: in tree_nr );
procedure Nt_Display_Aux ( a: in tree_nr ; str_shift: in string );
function Nt_Search ( a: in tree_nr; e: in T ) return tree_nr;
procedure Nt_Search_Aux ( tree :in tree_nr ; e: in T ; tree_curr: out tree_nr ; stop: in out boolean ); 
function Nt_Number_Children ( a: in tree_nr ) return integer;
function Nt_Is_Leaf ( a: in tree_nr ) return boolean;
function Nt_Is_Root ( a: in tree_nr ) return boolean;
procedure Insert_First_Child ( a: in out tree_nr ; a_ins: in out tree_nr);

-- modification

procedure Nt_Change_Value ( a: in out tree_nr; e: in T );
procedure Nt_Insert_Child ( tree: in out tree_nr; tree_i: in out tree_nr );
procedure Nt_Insert_Brother ( tree: in out tree_nr; tree_i: in out tree_nr );
procedure Nt_Delete_Child ( a: in out tree_nr ; n: in integer );
procedure Nt_Delete_Brother ( a: in out tree_nr ; n: in integer );
procedure Nt_Change( a: in out tree_nr );

private

type node;
type tree_nr is access node;
type node is record
   val: T; 
   first_child: tree_nr;
   brother: tree_nr;
   father: tree_nr;
end record; 

end tree_nary;

