-- paramtres gnriques: 
-- type T des valeurs de l'arbre n-aire
-- procedure ecrire 
-- fonction qui agit sur tous les lments de l'arbre
  
generic

type T is private;
with procedure ecrire ( a: in T );
with function fonction_main ( a: in T) return T;
-- partie spcifications du paquetage

package arbre_nr is

type arb_nr is private;

-- exception

-- arbre vide
arbre_vide: exception;
-- pas de parent  
parente_vide: exception;


-- cration

function An_Creer_Vide return arb_nr;
function An_Creer_Feuille(valeur: in T) return arb_nr;

-- consultation 

function An_Vide ( a: in arb_nr ) return boolean;
function An_Valeur ( a: in arb_nr ) return T;
function An_Pere ( a: in arb_nr ) return arb_nr;
function An_Fils ( a: in arb_nr; n: in integer ) return arb_nr;
function An_Frere ( a: in arb_nr; n: in integer ) return arb_nr;
procedure An_Afficher ( a: in arb_nr );
procedure An_Afficher_Aux ( a: in arb_nr ; str_decal: in string );
function An_Rechercher ( a: in arb_nr; e: in T ) return arb_nr;
procedure An_Rechercher_Aux ( arb :in arb_nr ; e: in T ; arb_cour: out arb_nr ; arret: in out boolean ); 
function An_Nombre_Fils ( a: in arb_nr ) return integer;
function An_Est_Feuille ( a: in arb_nr ) return boolean;
function An_Est_Racine ( a: in arb_nr ) return boolean;
procedure Inserer_Premier_Fils ( a: in out arb_nr ; a_ins: in out arb_nr);


-- modification

procedure An_Changer_Valeur ( a: in out arb_nr; e: in T );
procedure An_Inserer_Fils ( arb: in out arb_nr; arb_i: in out arb_nr );
procedure An_Inserer_Frere ( arb: in out arb_nr; arb_i: in out arb_nr );
procedure An_Supprimer_Fils ( a: in out arb_nr ; n: in integer );
procedure An_Supprimer_Frere ( a: in out arb_nr ; n: in integer );
procedure An_Changer( a: in out arb_nr );


private

type noeud;
type arb_nr is access noeud;
type noeud is record
   val: T; 
   premier_fils: arb_nr;
   frere: arb_nr;
   pere: arb_nr;
end record; 





end arbre_nr;

