package body arbre_quater is

-- Cration

-----------------------------------------------------------------
---- procdure Aq_Construire: cre un arbre 4-aire  partir d'une
---- valeur et de 4 arbres fils
---- paramtres: arb_res, l'arbre construit  
--              val, la valeur du pre 
----            a_no, a_ne, a_so, a_se, respectivement les fils 
----            nord ouest, nord est, sud ouest, sud est.
---- post-conditions: si un des fils est vide, on leve l'exception
---- filsq_vide
------------------------------------------------------------------

procedure Aq_Construire( valeur: in T; a_no, a_ne, a_so, a_se: in out arb_quat; arb_res: out arb_quat ) is

begin

-- Si un des fils est vide, on leve l'exception filsq_vide 
if (Aq_Vide(a_no) or Aq_Vide(a_ne) or Aq_Vide(a_so) or Aq_Vide(a_se)) then
   raise filsq_vide;
-- sinon on construit l'arbre 4-aire	
  else 
   arb_res:=Aq_Creer_Feuille(valeur);
   An_Inserer_Fils(arb_res,a_se);
   An_Inserer_Fils(arb_res,a_so);
   An_Inserer_Fils(arb_res,a_ne);
   An_Inserer_Fils(arb_res,a_no);

end if;
    
end Aq_Construire;


-- Consultation 


--------------------------------------------------------------
---- fonction Aq_Nord_Ouest: retourne le fils nord ouest d'un
---- arbre 4-aire
---- paramtres: a arbre 4-aire 
--------------------------------------------------------------

function Aq_Nord_Ouest( a: in arb_quat ) return arb_quat is

begin

return An_fils(a,1);

end Aq_Nord_Ouest;  


--------------------------------------------------------------
---- fonction Aq_Nord_Est: retourne le fils nord est d'un
---- arbre 4-aire
---- paramtres: a arbre 4-aire 
--------------------------------------------------------------

function Aq_Nord_Est( a: in arb_quat ) return arb_quat is

begin

return An_fils(a,2);

end Aq_Nord_Est;  

--------------------------------------------------------------
---- fonction Aq_Sud_Ouest: retourne le fils sud ouest d'un
---- arbre 4-aire
---- paramtres: a arbre 4-aire 
--------------------------------------------------------------

function Aq_Sud_Ouest( a: in arb_quat ) return arb_quat is

begin

return An_fils(a,3);

end Aq_Sud_Ouest;  



--------------------------------------------------------------
---- fonction Aq_Sud_Est: retourne le fils sud est d'un
---- arbre 4-aire
---- paramtres: a arbre 4-aire 
--------------------------------------------------------------

function Aq_Sud_Est( a: in arb_quat ) return arb_quat is

begin

return An_fils(a,4);

end Aq_Sud_Est;  

end arbre_quater;

