-- paramtres gnriques: 
-- type T des valeurs de l'arbre quaternaire
-- procedure ecrire 
-- fonction fonction_main utilise dans Aq_Changer
with arbre_nr;

generic

type T is private;
with procedure ecrire ( a: in T );
with function fonction_main ( a: in T) return T;

-- partie spcifications du paquetage

package arbre_quater is

--instanciation du paquetage arbre_nr
package arbre_nr_gen is new arbre_nr(T,ecrire,fonction_main);
use arbre_nr_gen;

-- type arb_quat qui est un sous-type de arb_nr
subtype arb_quat is arb_nr;

-- exception

-- arbre vide
arbreq_vide: exception renames arbre_vide ;
-- pas de parent  
parenteq_vide: exception renames parente_vide;
-- un des fils de l'arbre quaternaire est vide
filsq_vide: exception;

-- cration

function Aq_Creer_Vide return arb_quat renames An_Creer_Vide;
function Aq_Creer_Feuille ( valeur: in T ) return arb_quat renames An_Creer_Feuille;
procedure Aq_Construire ( valeur: in T; a_no, a_ne, a_so, a_se: in out arb_quat; arb_res: out arb_quat ); 

-- consultation 

function Aq_Vide ( a: in arb_quat ) return boolean renames An_Vide;
function Aq_Valeur ( a: in arb_quat ) return T renames An_Valeur;
function Aq_Pere ( a: in arb_quat ) return arb_quat renames An_Pere;
function Aq_Fils ( a: in arb_quat; n: in integer ) return arb_quat renames An_Fils;
function Aq_Frere ( a: in arb_quat; n: in integer ) return arb_quat renames An_Frere;
function Aq_Nord_Ouest ( a: in arb_quat ) return arb_quat;
function Aq_Nord_Est ( a: in arb_quat ) return arb_quat;
function Aq_Sud_Ouest ( a: in arb_quat ) return arb_quat;
function Aq_Sud_Est ( a: in arb_quat ) return arb_quat;
procedure Aq_Afficher ( a: in arb_quat ) renames An_Afficher;
function Aq_Rechercher ( a: in arb_quat; e: in T ) return arb_quat renames An_Rechercher;
function Aq_Est_Feuille ( a: in arb_quat ) return boolean renames An_Est_Feuille;
function Aq_Est_Racine ( a: in arb_quat ) return boolean renames An_Est_Racine;


-- modification

procedure Aq_Inserer_Frere ( a: in out arb_quat ; a_i: in out arb_quat ) renames An_Inserer_Frere;
procedure Aq_Inserer_Fils ( a: in out arb_quat ; a_i: in out arb_quat ) renames An_Inserer_Fils;
procedure Aq_Changer_Valeur ( a: in out arb_quat; e: in T ) renames An_Changer_Valeur;
procedure Aq_Changer( a: in out arb_quat ) renames An_Changer;

end arbre_quater;

