with text_io;use text_io;
with arbre_nr;

procedure main_arb_nr is

procedure ecrire_int ( a: in integer);
function fonc_arb ( e: in integer) return integer;
-- instanciation du paquetage arbre_nr
package arbre_nr_int is new arbre_nr(integer,ecrire_int,fonc_arb);
use arbre_nr_int;

package entier is new integer_io(integer);
use entier;

a,a_r,a_t,arb,arb_ins: arb_nr; -- arbres utiliss dans le PP

e,n: integer; -- valeurs utilises dans les entres sorties
bool: boolean; -- rsultat de An_Vide;

choix_menu: integer;
exit_menu: boolean;

-------------------------------------------
---- procedure ecrire : procedure passe en 
---- paramtre gnrique ; affiche l'lment 
---- de type integer
-------------------------------------------

procedure ecrire_int( a: in integer) is

begin

put(a,0);

end ecrire_int;

------------------------------------------------
---- fonction fonc_arb : fonction applique  
---- chaque lment de l'arbre 
---- retourne un entier
------------------------------------------------

function fonc_arb ( e: integer) return integer is

begin

return (2*e);

end fonc_arb;

-- dbut du programme principal

begin 

exit_menu:=false;

loop
 begin
    new_line;
    put_line("****************** Programme de test du paquetage Arbre n-aire ***************");    
    put_line("Faites un choix entre 1 et 20");
    put_line("1 - creer un arbre n-aire vide");
    put_line("2 - creer un arbre n-aire avec une valeur, sans fils, ni frere, ni pere");
    put_line("3 - detecter si un arbre est vide ou non");
    put_line("4 - retourner la valeur range  la racine de l'arbre");
    put_line("5 - retourner l'arbre pere d'un arbre");
    put_line("6 - retourner l'arbre nieme fils d'un arbre");
    put_line("7 - retourner l'arbre nieme frre d'un arbre");
    put_line("8 - afficher le contenu complet de l'arbre");
    put_line("9 - rechercher une valeur dans un arbre et retourne l'arbre dont la valeur est racine si elle est trouveee, un arbre vide sinon");
    put_line("10 - retourner le nombre de fils au premier niveau d'un arbre");
    put_line("11 - dtecter si un arbre est une feuille (pas de fils)");    
    put_line("12 - dtecter si un arbre est sanpere");
    put_line("13 - changer la valeur range  la racine d'un arbre");
    put_line("14 - insrer un arbre sanfrere en position de premier fils d'un arbre");
    put_line("15 - insrer un arbre sanfrere en position de premier frre d'un arbre");
    put_line("16 - supprimer le nieme fils d'un arbre");
    put_line("17 - supprimer le nieme frere d'un arbre");
    put_line("18 - appliquer une fonction a chaque element de l'arbre");            
    put_line("19 - initialiser un arbre");
    put_line("20 - sortir");
    get(choix_menu);
    
    case choix_menu is
                  -- cree un arbre vide
                  when 1 => a:=An_Creer_Vide; 			       		  
		  -- cree une feuille
		  when 2 => put_line("Entrer une valeur");
		              get(e);
		              a:=An_Creer_Feuille(e);
		  -- dtecte si un arbre est vide ou pas
		  when 3 => bool:=An_Vide(a);
		              if bool then
			         put_line("Arbre vide");
				else
				 put_line("Arbre non vide");
			      end if;
		  -- retourne la valeur range  la racine d'un arbre	      			      		  
		  when 4 => e:=An_Valeur(a);
		              ecrire_int(e);
		  -- retourne l'arbre pre d'un arbre	      
                  when 5 => a_r:=An_Pere(a);
		  -- retourne l'arbre nime fils d'un arbre
		  when 6 => put("Entrer un nombre :");
		            get(n);
		            a_r:=An_Fils(a,n);
			    ecrire_int(An_Valeur(a_r));  			      
		  -- retourne l'arbre nime frre d'un arbre
		  when 7 => put("Entrer un nombre :");
		            get(n);
		            a_r:=An_Frere(a,n);
			    ecrire_int(An_Valeur(a_r));  
		  -- affiche le contenu complet de l'arbre
		  when 8 => new_line;
			          An_Afficher(a);
		  -- recherche une valeur dans un arbre
		  when 9 => put("Entrer un nombre :");
		            get(e);
		            a_r:=An_Rechercher(a,e);
			    put("La valeur cherchee est : "); 
			    ecrire_int(An_Valeur(a_r));  
		  -- retourne le nombre de fils au premier niveau d'un arbre
		  when 10 => n:=An_Nombre_Fils(a);
		               put("Nombre de fils");
			       put(n);
			       new_line;
		  -- dtecte si un arbre est une feuille	       
	          when 11 => bool:=An_Est_Feuille(a);
		             if bool then
			        put_line("Cet arbre est une feuille");
			       else
				put_line("Cet arbre n'est pas une feuille");
			       end if;           
		  -- dtecte si un arbre est sans pre
		  when 12 => bool:=An_Est_Racine(a);
		             if bool then
			        put_line("L'arbre est sans pere");
			       else
				put_line("L'arbre a un pere");
			     end if;       
		  -- change la valeur range  la racine d'un arbre	     
                  when 13 => put("Entrer la nouvelle valeur pour la racine");
		             get(e);
			     An_Changer_Valeur(a,e);
			     put_line("La nouvelle valeur est");
			     ecrire_int(An_Valeur(a));  
                   -- insre un arbre sans frre en position de premier fils           
                  when 14 => put("Entrer une valeur");
			     get(e);
		             arb:=An_Creer_Feuille(e);
		             for i in 1..4 loop
			         put("Entrer une valeur pour le premier fils et les freres");
				 get(e);
		                 arb_ins:=An_Creer_Feuille(e);
			         An_Inserer_Fils(arb,arb_ins);
			     end loop;
			     a:=arb;
		    -- insre un arbre sans frre en position de premier frre     
	           when 15 => for i in 1..4 loop
			         put("Entrer une valeur pour les freres");
				 get(e);
		           arb_ins:=An_Creer_Feuille(e);
			         An_Inserer_Frere(a,arb_ins);
			      end loop;
		    -- supprime le n-ime fils d'un arbre	      
                   when 16 => put("Entrer le numero du fils a supprimer");
		              get(n); 
			      An_Supprimer_Fils(a,n);
		    -- on supprime le n-ime frre d'un arbre
                   when 17 => put("Entrer le numero du frere a  supprimer");
		              get(n); 
			      An_Supprimer_Frere(a,n);
		    -- on applique la fonction passe en paramtre gnrique	      
		   when 18 => An_Changer(a);	       
		   -- procdure d'initialisation
                   when 19 => put("Entrer une valeur");
			         get(e);
		           arb:=An_Creer_Feuille(e);
		           for i in 1..4 loop
			         put("Entrer une valeur pour les premiers fils");
				       get(e);
		           arb_ins:=An_Creer_Feuille(e);
			         An_Inserer_Fils(arb,arb_ins);
			     end loop;
			     
			     for i in 1..2 loop
			         put("Entrer une valeur pour le 2me et 3me fils");
		           get(e);
		           arb_ins:=An_Creer_Feuille(e);
			         Inserer_Premier_Fils(arb,arb_ins);    
			     end loop;
			    
			     for i in 1..4 loop
			         put("Entrer une valeur pour le premier fils et les freres");
				       get(e);
		           arb_ins:=An_Creer_Feuille(e);
			         An_Inserer_Fils(arb,arb_ins);
			     end loop;
			   
			     for i in 1..2 loop
			         put("Entrer une valeur pour les freres");
				       get(e);
		           arb_ins:=An_Creer_Feuille(e);
			         An_Inserer_Frere(arb,arb_ins);
			     end loop;
			     a:=arb;
			     
                  when 20 => exit_menu:=true;
		  
		  when others => put("Erreur, Entrer un nombre entre 1 et 20");

    end case;         
       
                  exit when exit_menu=true;
		  
exception

  when constraint_error => put_line("Erreur, acces a une zone non allouee");
	when arbre_vide => put_line("Erreur, arbre vide");
  when parente_vide => put_line("Erreur, la parente que vous demandez n'existe pas");		  
end;
end loop;

end main_arb_nr;




