with text_io; use text_io;

package body pimage is

-- instanciation du paquetage integer_io sur les entiers
package entier is new integer_io(integer);
use entier;

---------------------------------------------------------
---- fonction_main: fonction qui prend pour paramtre un 
---- entier et retourne un entier
---------------------------------------------------------

function fonction_main( a:in integer) return integer is

begin

return 2*a;

end fonction_main;

---------------------------------------------------------
---- procdure ecrire: crit l'entier pass en 
---- paramtre
---------------------------------------------------------

procedure ecrire_int( a: in integer ) is

begin

put(a,0);

end ecrire_int;

-------------------------------------------------------------------------
---- fonction get_bleu qui retourne la valeur de la couleur primaire bleu
----  partir d'un pixel
---- paramtre: p de type pixel
---- retourne c de type couleur_primaire
-------------------------------------------------------------------------

function get_bleu( p: in pixel ) return couleur_prim is
begin
return couleur_prim(p);
end get_bleu;

--------------------------------------------------------------------------
---- fonction get_vert qui retourne la valeur de la couleur primaire vert
----  partir d'un pixel
---- paramtre: p de type pixel
---- retourne c de type couleur_primaire
--------------------------------------------------------------------------

function get_vert( p: in pixel ) return couleur_prim is
begin
return couleur_prim(p/2**8);
end get_vert;

---------------------------------------------------------------------------
---- fonction get_rouge qui retourne la valeur de la couleur primaire rouge
----  partir d'un pixel
---- paramtre: p de type pixel
---- retourne c de type couleur_primaire
---------------------------------------------------------------------------

function get_rouge( p: in pixel ) return couleur_prim is
begin
return couleur_prim(p/2**16);
end get_rouge;

----------------------------------------------------------
---- fonction qui reconstitue une couleur  partir de 3 
---- couleurs primaires
---- paramtres: bleu, vert, rouge les 3 couleurs primaires
---- retourne la couleur code sur 32 bits
-----------------------------------------------------------

function prim_to_couleur( bleu,vert,rouge: in couleur_prim ) return pixel is

coul: pixel;

begin
coul:=pixel(bleu+vert*2**8+rouge*2**16);
return coul;
end prim_to_couleur;

-------------------------------------------------------------
---- procedure creer_im_test: cre une image test pour la 
---- compression
---- parametres: l'image cree im et n sa dimension
-------------------------------------------------------------

procedure creer_im_test( im: out image; n: in integer ) is

begin

for i in 1..n loop
    for j in 1..n loop
      im(i,j):=255;
    end loop;
end loop;

for i in 1..n/2 loop
    for j in 1..n/2 loop
          im(i,j):=0;    
    end loop;
end loop;

for i in n/4+1..n/2 loop
      for j in n/4+1..n/2 loop
            im(i,j):=100;    
      end loop;
end loop;

for i in 1..n/4 loop
      for j in 3*n/4..n loop
            im(i,j):=30;    
      end loop;
end loop;

for i in 1..n/8 loop
      for j in 1..n/8 loop
            im(i,j):=10;    
      end loop;
end loop;

for i in 7*n/8..n loop
      for j in 7*n/8..n loop
            im(i,j):=20;    
      end loop;
end loop;

end creer_im_test;

---------------------------------------------------------------------
---- procdure charger_image: charge une image  partir d'un fichier
---- paramtres: im l'image  charger, n la dimension de l'image
---------------------------------------------------------------------

procedure charger_image( im: out image; n: out pixel ) is

filename: string(1..4);
f: pack_pixel.file_type;
dim:pixel;

begin

put("Entrer un nom de fichier (4 caractres): ");
get(filename);
skip_line;
open(f,in_file,filename);
read(f,dim);
n:=dim;

for i in 1..n loop
      for j in 1..n loop
        read(f,im(integer(i),integer(j)));
      end loop;
end loop;
close(f);

end charger_image;

----------------------------------------------------------------------
---- procdure enegistrer_image: enregistre une image dans un fichier
---- paramtres: im l'image  enregistrer, n sa dimension
----------------------------------------------------------------------

procedure enregistrer_image ( im: in image; n: in pixel ) is

filename: string(1..4);
f: pack_pixel.file_type;

begin

put("Entrer un nom de fichier (4 caractres): ");
get(filename);
skip_line;
create(f,out_file,filename);
write(f,n);
for i in 1..n loop
      for j in 1..n loop
            write(f,im(integer(i),integer(j)));
      end loop;
end loop;
close(f);      
      
end enregistrer_image;

-----------------------------------------------------------------------
---- procedure enregistrer_imagec: enregistre une image compress dans
---- un fichier  partir de l'arbre.
---- paramtres: a l'arbre construit, n la dimension de l'image
-----------------------------------------------------------------------

procedure enregistrer_imagec( a: in arb_im ; n: in pixel ) is

filename: string(1..4);
f: pack_pixel.file_type;

begin

put("Entrer un nom de fichier (4 caractres): ");
get(filename);
skip_line;
create(f,out_file,filename);
write(f,n);
arb_to_imc(a,f);
close(f);      

end enregistrer_imagec;

-------------------------------------------------------------------------
---- procdure afficher_image: affiche une image en faisant une conversion
---- explicite de la valeur dcimale du pixel en caractre.
---- paramtres: im l'image  afficher, n sa dimension
-------------------------------------------------------------------------

procedure afficher_image( im: in image; n: in integer ) is

begin

new_line;
put("La dimension de l'image est");
put(n);
new_line;
new_line;
for i in 1..n loop
    for j in 1..n loop
        put(integer(im(integer(i),integer(j))));
    end loop;
    new_line;
end loop;
new_line;
    
end afficher_image;

-----------------------------------------------------------------
---- procdure charger_im_encod : construit un arbre  partir de
---- la squence compresse
---- paramtres: a l'arbre reconstruit, n la dimension de l'image
----             originale            
-----------------------------------------------------------------

procedure charger_im_encod( a: out arb_im ; n: out pixel ) is

filename: string(1..4);
f: pack_pixel.file_type;
-- dimension de l'image originale
dim:pixel;

begin

put("Entrer un nom de fichier (4 caractres): ");
get(filename);
skip_line;
open(f,in_file,filename);
-- on lit la dimension
read(f,dim);
n:=dim;
a:=imc_to_arb(f);
close(f);

end charger_im_encod;


---------------------------------------------------------------------
---- fonction coul_moy: calcule la couleur moyenne de l'image  partir
---- de la moyenne des couleurs primaires.
---- paramtres: im de type image
---- retourne une couleur
---------------------------------------------------------------------

function coul_moy( im: in image; n: in integer ) return pixel is

bleu_moy: integer;
vert_moy: integer;
rouge_moy: integer;

begin

bleu_moy:=0;
vert_moy:=0;
rouge_moy:=0;

for i in 1..n loop
    for j in 1..n loop
        bleu_moy:=bleu_moy+get_bleu(im(i,j));
	vert_moy:=vert_moy+get_vert(im(i,j));
        rouge_moy:=rouge_moy+get_rouge(im(i,j));
    end loop;
end loop;    

bleu_moy:=bleu_moy/n**2;
vert_moy:=vert_moy/n**2;
rouge_moy:=rouge_moy/n**2;

return prim_to_couleur(bleu_moy,vert_moy,rouge_moy);

end coul_moy;

----------------------------------------------------------------------
---- fonction est_homogene: fonctionne qui dtermine si la zone de 
---- taille n est homogne. retourne un boolen 
---- paramtres: im l'image
----             taille n de la zone
----             tol la tolrance pour l'homognit
-----------------------------------------------------------------------              

function est_homogene( im: in image; n: in integer; tol: in intensite ) return boolean is

result: boolean;
val,i,j: integer;
c_moy: integer;

begin
result:=true;

case tol is
     -- tolrance maximale autorise, l'image est considre comme homogne
     when intensite'last =>  return true;
     -- tolrance minimale, on compare le premier point avec tous les 
     -- autres
     when intensite'first => val:=integer(im(1,1)); 
                             i:=1;
                             while i<=n and result loop
			           j:=1;
			           while j<=n and result loop
				         result:=(im(i,j)=pixel(val));
					 j:=j+1;
				   end loop;
		             i:=i+1;
			     end loop;
			     return result;
      -- cas gnral: on calcule la couleur moyenne et on extrait les 3
      -- couleurs primaires moyennes que l'on va comparer aux pixels 
      -- de l'image avec la condition que abs(couleur_primaire-moyenne) <=
      -- tolerance  			     
      when others => c_moy:=integer(coul_moy(im,n));
                     i:=1;
		     while i<=n and result loop
		           j:=1;
			   while j<=n and result loop
result:=(abs(get_bleu(im(i,j))-get_bleu(pixel(c_moy)))<=tol) and (abs(get_vert(im(i,j))-get_vert(pixel(c_moy)))<=tol) and (abs(get_rouge(im(i,j))-get_rouge(pixel(c_moy)))<=tol); 			     
				 j:=j+1;
			   end loop;
			   i:=i+1;
		     end loop;      
                     return result;
end case;
       	               
end est_homogene;


------------------------------------------------------------
---- fonction imc_to_arb: retourne un arbre  partir de 
---- l'image comprsse
---- paramtres: f le nom logique du fichier comprss
-------------------------------------------------------------

function imc_to_arb( f: in pack_pixel.file_type ) return arb_im is

-- fils de l'arbre quaternaire
a,a_no,a_ne,a_so,a_se: arb_im;
v: pixel;

begin

read(f,v);
-- si la valeur vaut -1 (cod par 2**24), on cre une feuille
if v /= 2**24 then
   a:=Aq_Creer_Feuille(integer(v));
  else
   a_no:=imc_to_arb(f);
   a_ne:=imc_to_arb(f);
   a_so:=imc_to_arb(f);
   a_se:=imc_to_arb(f);
   Aq_Construire(-1,a_no,a_ne,a_so,a_se,a);
end if;
return a;	
	  
end imc_to_arb;


--------------------------------------------------------------------
----- procedure arb_to_imc: permet de passer de l'arbre  la squence
----- compresse.
----- paramtres: a l'arbre construit, f le nom logique du fichier
--------------------------------------------------------------------

procedure arb_to_imc( a: in arb_im; f: in pack_pixel.file_type ) is

begin

if Aq_Vide(a) then
   null;
  else
   if Aq_Valeur(a)=-1 then
      write(f,2**24);
     else
      write(f,pixel(Aq_Valeur(a)));
   end if;   
   arb_to_imc(Aq_Fils(a,1),f);
   arb_to_imc(Aq_Frere(a,1),f);
end if;   

end arb_to_imc;


-------------------------------------------------------------------
---- procedure arb_to_im: permet de reconstituer l'image originale
----  partir de l'image compresse.
---- paramtres: a l'arbre reconstitu, im l'image  construire,
---- i_d,i_f,j_d,j_f les indices de dbut et de fin, n la dimension
---- de l'image originale
-------------------------------------------------------------------

procedure arb_to_im ( a: in arb_im ; im: out image ; i_d,i_f,j_d,j_f: in integer ) is

begin

-- cas terminal
if Aq_Vide(a) then
   null;-- cas gnral
  else if Aq_Valeur(a) /= -1 then
          for i in i_d..i_f loop
	           for j in j_d..j_f loop
	               im(i,j):=pixel(Aq_Valeur(a));
		         end loop;
					end loop;

     -- on parcourt tous les fils d'une cellule
     else
         arb_to_im(Aq_Nord_Ouest(a),im,i_d,i_f-(i_f-i_d+1)/2,j_d,j_f-(j_f-j_d+1)/2);
	 arb_to_im(Aq_Nord_Est(a),im,i_d,i_f-(i_f-i_d+1)/2,j_f-(j_f-j_d+1)/2+1,j_f);
	 arb_to_im(Aq_Sud_Ouest(a),im,i_f-(i_f-i_d+1)/2+1,i_f,j_d,j_f-(j_f-j_d+1)/2);
	 arb_to_im(Aq_Sud_Est(a),im,i_f-(i_f-i_d+1)/2+1,i_f,j_f-(j_f-j_d+1)/2+1,j_f);

    end if;


end if;
	
end arb_to_im;	 	  
          
    
----------------------------------------------------------------
---- procedure im_to_arb: cre un arbre  partir d'une image
---- paramtres: im l'image, n sa dimension, a l'arbre  crer,
---- tol la tolrance utilis par la fonction est_homogene
----------------------------------------------------------------

procedure im_to_arb( im: in image; n: in integer; a: out arb_im; tol: in intensite) is

im_no,im_ne,im_so,im_se: image(1..n/2,1..n/2);
a_no,a_ne,a_so,a_se: arb_im;

begin
-- cas o la dimension vaut 1
if n=1 then
   a:=Aq_Creer_Feuille(integer(im(1,1)));
  -- si elle est homogne, on cre une feuille avec la couleur moyenne 
  else if est_homogene(im,n,tol) then
          a:=Aq_Creer_Feuille(integer(coul_moy(im,n)));
         else -- on construit l'arbre en divisant les dimensions par deux
           for i in 1..n/2 loop
	       for j in 1..n/2 loop
	           im_no(i,j):=im(i,j);
		   im_ne(i,j):=im(i,j+n/2);
		   im_so(i,j):=im(i+n/2,j);
		   im_se(i,j):=im(i+n/2,j+n/2);
	       end loop;
	   end loop;    	      
          
           im_to_arb(im_no,n/2,a_no,tol);
	   im_to_arb(im_ne,n/2,a_ne,tol);
	   im_to_arb(im_so,n/2,a_so,tol);
	   im_to_arb(im_se,n/2,a_se,tol);
	   Aq_Construire(-1,a_no,a_ne,a_so,a_se,a);	    
        
       end if;
end if;       
	
end im_to_arb;

-----------------------------------------------------------
----- procedure thresh_im: fait un seuillage sur l'image
----- paramtres: im l'image  traiter, n sa dimension,
----- le seuil
-----------------------------------------------------------

procedure thresh_im( im: in out image ; n: in integer ; seuil: in integer ) is

begin

for i in 1..n loop
    for j in 1..n loop
        if (integer(im(i,j))<= seuil) then
	   im(i,j):=0;
	  else
	    im(i,j):=1;
	end if;    
	end loop;	
end loop;

end thresh_im;

end pimage;

