with sequential_io;
with arbre_quater;

generic 

with procedure ecrire( a: in integer );
with function fonction( a: in integer ) return integer;

package pimage is

-- instanciation du paquetage arbre_quater
package p_arbre_q is new arbre_quater(integer,ecrire,fonction);
use p_arbre_q;

-- sous type arb_im 
subtype arb_im is arb_quat;
-- dfinition de la couleur primaire
subtype couleur_prim is integer range 0..255;
-- dfinition du pixel: valeur code sur 32 bits
type pixel is mod 2**32;

package pack_pixel is new sequential_io(pixel); 
use pack_pixel;

-- tableau contenant l'image
type image is array (integer range <>,integer range <>) of pixel;
type image_comp is array (1..2**18) of pixel;
subtype intensite is integer range 0..100;
-- fonctions pour obtenir les couleurs primaires  partir d'une couleur
function get_bleu( p: in pixel ) return couleur_prim;
function get_vert( p: in pixel ) return couleur_prim;
function get_rouge( p: in pixel ) return couleur_prim;

-- fonction pour calculer la couleur moyenne d'une image
function coul_moy( im: in image; n: in integer ) return pixel;
-- fonction qui retourne un pixel  partir des 3 couleurs primaires
function prim_to_couleur( bleu,vert,rouge: in couleur_prim ) return pixel;

-- procdure pour la cration d'une image compresse et sa dcompression
-- et pour les entres/sorties.

procedure charger_image( im: out image; n: out pixel );
procedure enregistrer_image( im: in image; n: in pixel );
procedure afficher_image ( im: in image; n: integer );
procedure afficher_arbre( a: in arb_im ) renames Aq_Afficher;
procedure charger_im_encod( a: out arb_im ; n: out pixel );
function imc_to_arb( f: in pack_pixel.file_type ) return arb_im;
procedure creer_im_test( im: out image; n: in integer );
procedure im_to_arb( im: in image; n: in integer; a: out arb_im; tol: in intensite );
procedure arb_to_imc( a: in arb_im; f: in pack_pixel.file_type );
procedure enregistrer_imagec( a: in arb_im ; n: in pixel );
procedure arb_to_im ( a: in arb_im ; im: out image ; i_d,i_f,j_d,j_f: in integer );
procedure thresh_im( im: in out image ; n: in integer ; seuil: in integer );
end pimage;
